searchNodes=[{"doc":"A set of convenience functions for concurrent, asynchronous tasks, loosely inspired by JavaScript's Promises.Why?While Elixir's Task module provides an API for easy creation of concurrent processes, it does so by blocking the caller process on calls to Task.await/2 or Task.async_stream/3. However, sometimes it is beneficial to operate asynchronously, in a manner somewhat similar to JavaScript's Promises - let the work be done in the background and then act on the results when everything is resolved.Taskmaster wraps around the built-in Task module to provide a set of useful functions for doing just that.","ref":"Taskmaster.html","title":"Taskmaster","type":"module"},{"doc":"Creates a process, that runs funs concurrently and sends a message to the caller when all of them either return a value or one of them either crashes or returns an error.Possible messages:{:all_results, results} when all the funs return a result{:all_error, error} when either function:returns an {:error, reason}crashesexceeds a :timeout optionThe process created by all/2 by default isn't linked to the caller process. It can be started as a linked process by passing a link: true option.Options:timeout - a timeout for each function (defaults to 5000):link - should the started process by linked to the caller (defaults to false)Example:iex(1)&gt; Taskmaster.all( ...(1)&gt; [ ...(1)&gt; fn -&gt; ...(1)&gt; :one ...(1)&gt; end, ...(1)&gt; fn -&gt; ...(1)&gt; :timer.sleep(50) ...(1)&gt; :two ...(1)&gt; end, ...(1)&gt; fn -&gt; ...(1)&gt; :timer.sleep(200) ...(1)&gt; :three ...(1)&gt; end ...(1)&gt; ], ...(1)&gt; timeout: 1000 ...(1)&gt; ) {:ok, #PID&lt;0.216.0&gt;} iex(2)&gt; flush() {:all_return_values, [:one, :two, :three]} :ok","ref":"Taskmaster.html#all/2","title":"Taskmaster.all/2","type":"function"},{"doc":"Creates a process, that runs funs concurrently and when the first one resolves, sends a message to the caller.Function resolves either by:returning a value, which results in a {:race_won, value} messagecrashing or returning a {:error, reason} tuple, which results in a {:race_interrupted, {:error | :exit, reason}} messageexceeding a :timeout options, which results in a {:race_interrupted, :timeout} messageThe process created by race/2 by default isn't linked to the caller process. It can be started as a linked process by passing a link: true option.Options:timeout - a timeout for each function (defaults to 5000):link - should the started process by linked to the caller (defaults to false)Example:iex(1)&gt; Taskmaster.race([ ...(1)&gt; fn -&gt; ...(1)&gt; :one ...(1)&gt; end, ...(1)&gt; fn -&gt; ...(1)&gt; :timer.sleep(200) ...(1)&gt; :two ...(1)&gt; end, ...(1)&gt; fn -&gt; ...(1)&gt; :timer.sleep(300) ...(1)&gt; :three ...(1)&gt; end ...(1)&gt; ]) {:ok, #PID&lt;0.178.0&gt;} iex(2)&gt; flush {:race_won, :one} :ok","ref":"Taskmaster.html#race/2","title":"Taskmaster.race/2","type":"function"},{"doc":"","ref":"Taskmaster.html#t:options/0","title":"Taskmaster.options/0","type":"type"},{"doc":"TaskmasterA set of convenience functions for concurrent, asynchronous tasks, loosely inspired by JavaScript's Promises. Pure Elixir, no dependencies.","ref":"readme.html","title":"Taskmaster","type":"extras"},{"doc":"def deps do [ {:taskmaster, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"Taskmaster - Installation","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/taskmaster.","ref":"readme.html#documentation","title":"Taskmaster - Documentation","type":"extras"}]